// A minimal Pilot application by Darrin Massena (darrin@massena.com)
// See www.massena.com/darrin/pilot for Pilot Software Development info

#include <Pilot.h>
#include ":Rsc:TemplateRsc.h"

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
	EventType evt;
	Word err;

	if (cmd != sysAppLaunchCmdNormalLaunch)
		return 0;

	FrmGotoForm(MainForm);

	do {
		extern Boolean ApplicationHandleEvent(const EventType *pevt);

		EvtGetEvent(&evt, evtWaitForever);

		if (!SysHandleEvent(&evt)) {
			if (!MenuHandleEvent(NULL, &evt, &err)) {
				if (!ApplicationHandleEvent(&evt)) {
					FrmDispatchEvent(&evt);
				}
			}
		}
	} while (evt.eType != appStopEvent);

	return 0;
}

Boolean ApplicationHandleEvent(const EventType *pevt)
{
	extern Boolean MainFormHandleEvent(const EventType *pevt);
	FormPtr pfrm;

	if (pevt->eType == frmLoadEvent) {

		Word fid = pevt->data.frmLoad.formID;
		pfrm = FrmInitForm(fid);

		FrmSetActiveForm(pfrm);
		FrmSetEventHandler(pfrm, (FormEventHandlerPtr)&MainFormHandleEvent);
		return true;
	}

	return false;
}

Boolean MainFormHandleEvent(const EventType *pevt)
{
	switch (pevt->eType) {
	case frmOpenEvent:
		{
			FormPtr pfrm = FrmGetActiveForm();
			FrmDrawForm(pfrm);
		}
		return true;
	}

	return false;
}
